#ifndef __AXCONTROL_H
#define __AXCONTROL_H

#include <windows.h>
#include <commctrl.h>
#include "AnsiString.h"

typedef void (*AX_EVENT_FUNC)(AnsiString SenderID, long wparam, long lparam);

#define MAX_PARAMS 0xFF

class CAXControl {
private:
    static void AddResult(void *ptr, char *data);
    static void AddEventParameter(void *ptr, char *data);
    static int EventNotify(void *ptr, DISPID dispIdMember,DISPPARAMS __RPC_FAR *Params, VARIANT __RPC_FAR *pVarResult);
    static int EventDone(void *ptr, DISPID dispIdMember, int parameters_count);

    /*AnsiList PARAMETERS;
    AnsiList LAST_RESULTS;
    AnsiList EVENT_PARAMETERS;*/
    AnsiString PARAMETERS[MAX_PARAMS];
    int PARAMETERS_COUNT;

    AnsiString LAST_RESULTS[MAX_PARAMS];
    int LAST_RESULTS_COUNT;

    AnsiString EVENT_PARAMETERS[MAX_PARAMS];
    int EVENT_PARAMETERS_COUNT;

    int  *EVENTS;
    int   EVENTS_COUNT;
    
    int EVENTS_ID;

    AnsiString SenderID;

    AX_EVENT_FUNC _EFUNC;
    /*void *spControl;*/
public:
    HWND Handle;

    static HMODULE LoadAXModule();
    static void FreeAXModule(HMODULE hMOD);

    CAXControl(HWND Parent, AX_EVENT_FUNC ef, AnsiString _SenderID);
    int InitControl(char *AXName, char *LicenceKey);
    int SetAXProperty(char *name/*, char *value*/);
    int AddParameter(char *parameter);
    int ExecuteMethod(char *method_name);

    int AddEventNotify(int event_dispid);
    int ClearEventsData();
    int AknowledgeEvent(int parameters);

    AnsiString GetEventParameter(int index);

    AnsiString GetLastResult(int index);

    int GetAXProperty(char *name);
    ~CAXControl();
};

#endif // __AXCONTROL_H
