#ifndef __CALLBACK_H
#define __CALLBACK_H

#include "ConceptClient.h"
#include <gtk/gtk.h>
//#include <glib.h>
/*#include <gtkmm.h>
#include <gtkmm/window.h>
#include <gtkmm/stock.h>
#include <gtkmm/enums.h>
#include <gtkmm/treeview.h>
#include <gtkmm/cellrenderer.h>
#include <gtkmm/viewport.h>
#include <gtkmm/menutoolbutton.h>
#include <gtkmm/button.h>
#include <gtkmm/dialog.h>*/
//#include "html.h"
#include "BasicMessages.h"
#include "components_library.h"
#include "EventHandler.h"
#include "PropertiesPanel.h"
#include <iostream>

#ifdef THIS
    #undef THIS
#endif

#define MAX_COLUMNS     0x400

#define START_EDITING   0x01
#define END_EDITING     0x02
#define CANCEL_EDITING  0x04
#define COLUMN_LINKED   0x08

typedef struct {
        char type;
        char events;
        void *ptr;
        //void *ptr2;
} DeturnatedColumn;

enum MyPackOptions
{
  MyPACK_SHRINK,
  MyPACK_EXPAND_PADDING,
  MyPACK_EXPAND_WIDGET
};

#define MAX_CONTROLS    0xFF
#ifdef _WIN32
    #include <windows.h>
#else
    #include <dlfcn.h>
    #define HMODULE void *
#endif

#ifdef _WIN32
    #define COOKIES     		"cookies\\"
    #define COMPONENTS          "components\\"
#else
    #define COOKIES     		"cookies/"
    #define COMPONENTS          "components/"
    //#define APP_PATH            "/opt/ConceptClient/"
#endif

typedef void (*UPDATE_CB)(bool init);

void SetTempDir(char *dir);
void InitLoginDialog(char *filename);
void InitInputDialog(char *title);
AnsiString GetDirectory();
void LoadControls(char *dir);
void UnloadControls();
void LocalIDLE();
void notify_recv_2(int percent, char *status, bool idle_call);

GtkImage *GetImageID(long id);
GtkComboBox *GetComboID(long id);

std::string UriDecode(const std::string & sSrc);
std::string UriEncode(const std::string & sSrc);

int MESSAGE_INIT(CConceptClient *CC, char *path, char *host, UPDATE_CB ustatus);
int MESSAGE_CALLBACK(Parameters *PARAM);
int QuitPending();
int LocalInvoker(void *context,int INVOKE_TYPE,...);

//GTKControl *GetControlID(long id);
long GetControlPtr(void *ptr);
//Glib::RefPtr<Gdk::Pixbuf> *ForcePixbuf(void *ptr);

GdkPixbuf *ForcePixbuf(void *ptr);


int RunApplication();
GtkWindow *AppWindow();

typedef void (*PRINT_API)(void *data);
void SetPrintCallback(PRINT_API cb);
#ifdef _WIN32
    #define TRAY_NOTIFY(title, text) WIN32Notify(title, text);
    void WIN32Notify(char *title, char *text);
    char *SLimit(char *str, int length);
#else
    #define TRAY_NOTIFY(title, text)
#endif

#define MY_ICON_VIEW(ptr)      GTK_ICON_VIEW(((DeturnatedIconView *)(ptr))->handle)
#define MY_COMBO_BOX(ptr)      GTK_COMBO_BOX(((DeturnatedComboBox *)(ptr))->handle)
#define MY_TREE_VIEW(ptr)      GTK_TREE_VIEW(((DeturnatedTreeView *)(ptr))->handle)

#define SAFE_WIDGET(item)       (item->type==CLASS_TREEVIEW) ? GTK_WIDGET(((DeturnatedTreeView *)(item->ptr))->handle): \
                                    ((item->type==CLASS_COMBOBOX) || (item->type==CLASS_COMBOBOXTEXT)) ? GTK_WIDGET(((DeturnatedComboBox *)(item->ptr))->handle) : \
                                        (item->type==CLASS_ICONVIEW) ? GTK_WIDGET(((DeturnatedIconView *)(item->ptr))->handle) : GTK_WIDGET(item->ptr)

#define IS_COMBOEDIT(item)       (item->type==CLASS_COMBOBOXTEXT)
#define COMBOEDIT(item)          G_OBJECT(gtk_bin_get_child(GTK_BIN(((DeturnatedComboBox *)item->ptr)->handle)))

#define SAFE_WIDGET2(item)       (item->type==CLASS_TREEVIEW) ? ((DeturnatedTreeView *)(item->ptr))->handle: \
                                    ((item->type==CLASS_COMBOBOX) || (item->type==CLASS_COMBOBOXTEXT)) ? ((DeturnatedComboBox *)(item->ptr))->handle : \
                                        (item->type==CLASS_ICONVIEW) ? ((DeturnatedIconView *)(item->ptr))->handle : item->ptr

#define SET_GPROP(target,prop,type,val) g_object_set(G_OBJECT(target), prop, (type)val, NULL);
#define GET_GPROP(target,prop,type,val,val_type) {\
                                            type res;\
                                            g_object_get(G_OBJECT(target), prop, &res, NULL);\
                                            val=(val_type)res;\
                                        }


class DeturnatedIconView/* : public Gtk::IconView*/ {
    public:
        GtkWidget *handle;
    private:
        DeturnatedColumn columns[MAX_COLUMNS];
        int columns_count;
        int position;
        AnsiString POST_STRINGS[MAX_COLUMNS];
        
        GtkListStore *m_refListModel;
        char created;

        //Gtk::TreeModel::ColumnRecord *crecord;
    public:

        DeturnatedIconView()/* : IconView()*/ {
            // nothing ...
            columns_count=0;
            position=0;
            created=0;
            handle=gtk_icon_view_new();
            m_refListModel=NULL;
            //crecord=new Gtk::TreeModel::ColumnRecord();
        }

        ~DeturnatedIconView() {
            /*for (int i=0;i<columns_count;i++) {
                    if (columns[i].type==1) 
                        delete (Gtk::TreeModelColumn<double> *)columns[i].ptr;
                    if (columns[i].type==2) 
                        delete (Gtk::TreeModelColumn<bool> *)columns[i].ptr;
                    else
                        delete (Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr;
            }*/
            //if (crecord)
            //    delete crecord;
        }

        void post_string(AnsiString s) {
            POST_STRINGS[position++]=s;
        }

        void create_model() {
            created=1;
            //m_refListModel=Gtk::ListStore::create(*crecord);
            GType *elems=new GType[columns_count];
            for (int i=0;i<columns_count;i++) {
                switch (columns[i].type) {
                    case 2://progress
                            elems[i]=G_TYPE_INT;
                            break;
                    case 0://string
                            elems[i]=G_TYPE_STRING;
                            break;
                    case 5://pixbuf
                            elems[i]=GDK_TYPE_PIXBUF;
                            break;
                    case 6://combo
                            elems[i]=G_TYPE_STRING;
                            break;
                    default: //bool
                            elems[i]=G_TYPE_BOOLEAN;
                            break;
                }
            }
            m_refListModel=gtk_list_store_newv(columns_count, elems);
            delete[] elems;

            gtk_icon_view_set_model(GTK_ICON_VIEW(handle), GTK_TREE_MODEL(m_refListModel));
            //g_object_unref(m_refListModel);
        }

        void create_if_not_created() {
            if (!created)
                create_model();
        }

        void clear_items() {
             if (!created)
                 return;
             gtk_list_store_clear(m_refListModel);
        }

        void delete_item(int position) {
            //Gtk::TreePath path;
            //path.append_index(position);
            GtkTreeIter iter;
            GtkTreeModel *model=gtk_icon_view_get_model(GTK_ICON_VIEW(handle));

            GtkTreePath *path=gtk_tree_path_new();
            gtk_tree_path_append_index(path, position);
            gtk_tree_model_get_iter (model, &iter, path);

            gtk_list_store_remove(GTK_LIST_STORE (model), &iter);
            //m_refListModel->erase(m_refListModel->get_iter(path));
            gtk_tree_path_free(path);
        }


        void update_item(AnsiString *value) {
            position=0;
            AnsiString *POST_STRINGS=this->POST_STRINGS;
            if (*value==(char *)"-1")
                *value=(char *)"";

            //Gtk::TreeModel::Row row;

            //row = *(m_refListModel->get_iter((Glib::ustring)value->c_str()));
            GtkTreeIter iter;
            GtkTreeModel *model=gtk_icon_view_get_model(GTK_ICON_VIEW(handle));

            GtkTreePath *path=gtk_tree_path_new();
            gtk_tree_path_append_index(path, value->ToInt());
            gtk_tree_model_get_iter (model, &iter, path);
            gtk_tree_path_free(path);


            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //gtk_list_store_set_value(m_refListModel, &iter, i, gv);
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        GdkPixbuf *pbuf=ForcePixbuf(ctrl);
                        gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, pbuf, -1);
                    }
                    no_ctl=true;
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
                }
                if (!no_ctl)
                    gtk_list_store_set_value(m_refListModel, &iter, i, &gval);
            }
        }

        void add_item(int insert_position=-1) {
            if (!created)
                create_model();

            position=0;
            //Gtk::TreeModel::Row row;
            GtkTreeIter iter;

            if (insert_position<0)
                gtk_list_store_append(m_refListModel, &iter);
            else {
                gtk_list_store_insert(m_refListModel, &iter, insert_position);
            }
            
            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //gtk_list_store_set_value(m_refListModel, &iter, i, gv);
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        GdkPixbuf *pbuf=ForcePixbuf(ctrl);
                        gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, pbuf, -1);
                    }
                    no_ctl=true;
                    //row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
                }
                if (!no_ctl)
                    gtk_list_store_set_value(m_refListModel, &iter, i, &gval);
            }
        }

        void add_column(/*char *column_name*/int col_type=0) {
            GtkCellRenderer *cell=NULL;
            if (col_type==2) {
                cell = gtk_cell_renderer_progress_new();

                columns[columns_count].type=col_type;
                columns[columns_count].ptr=cell;
                columns_count++;

                gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, TRUE );
                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "value", columns_count-1,
                                    NULL );
            } else
            if (col_type==5) {
                //cell = gtk_cell_renderer_pixbuf_new();

                columns[columns_count].type=col_type;
                columns[columns_count].ptr=0;//cell;
                columns_count++;

                /*gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, FALSE );
                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "pixbuf", columns_count-1,
                                    NULL );*/
            } else {
                //cell = gtk_cell_renderer_text_new();

                columns[columns_count].type=0;
                columns[columns_count].ptr=0;
                columns_count++;

                /*if (col_type!=0)
                    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, FALSE );
                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "text", columns_count-1,
                                    NULL );
                */
            }
        }

        void add_columns(int columns, int type=0) {
            for (int i=0;i<columns;i++)
                add_column(type);
        }

        void clear_all() {
            //clear();
            gtk_list_store_clear(m_refListModel);
            //delete crecord;
            //crecord=new Gtk::TreeModel::ColumnRecord();
            columns_count=0;
            position=0;
            created=0;
        }
};





class DeturnatedComboBox {
    public:
        GtkWidget *handle;
    private:
        DeturnatedColumn columns[MAX_COLUMNS];
        int columns_count;
        int position;
        AnsiString POST_STRINGS[MAX_COLUMNS];
        
        GtkListStore *m_refListModel;
        char created;
    public:

        DeturnatedComboBox(bool has_entry=false)/* : ComboBoxEntry()*/ {
            // nothing ...
            columns_count=0;
            position=0;
            created=0;
            if (has_entry)
                handle=gtk_combo_box_entry_new();
            else
                handle=gtk_combo_box_new();
            m_refListModel=NULL;
        }

        ~DeturnatedComboBox() {
            /*for (int i=0;i<columns_count;i++) {
                    if (columns[i].type==1) 
                        delete (Gtk::TreeModelColumn<double> *)columns[i].ptr;
                    if (columns[i].type==2) 
                        delete (Gtk::TreeModelColumn<bool> *)columns[i].ptr;
                    else
                        delete (Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr;
            }*/
        }

        void post_string(AnsiString s) {
            POST_STRINGS[position++]=s;
        }

        void set_text_col(int i) {
            if ((columns[i].type==1) || (columns[i].type==0)) {
                gtk_combo_box_entry_set_text_column(GTK_COMBO_BOX_ENTRY(handle), i);
            } else {
                std::cerr << "Concept Client: Can't set as text column a non-text column (image, boolean or control)";
            }

        }

        void create_model() {
            created=1;
            //m_refListModel=Gtk::ListStore::create(*crecord);
            GType *elems=new GType[columns_count];
            for (int i=0;i<columns_count;i++) {
                switch (columns[i].type) {
                    case 2://progress
                            elems[i]=G_TYPE_INT;
                            break;
                    case 0://string
                            elems[i]=G_TYPE_STRING;
                            break;
                    case 5://pixbuf
                            elems[i]=GDK_TYPE_PIXBUF;
                            break;
                    case 6://combo
                            elems[i]=G_TYPE_STRING;
                            break;
                    default: //bool
                            elems[i]=G_TYPE_BOOLEAN;
                            break;
                }
            }
            m_refListModel=gtk_list_store_newv(columns_count, elems);
            delete[] elems;

            gtk_combo_box_set_model(GTK_COMBO_BOX(handle), GTK_TREE_MODEL(m_refListModel));
        }

        void create_if_not_created() {
            if (!created)
                create_model();
        }

        void clear_items() {
             if (!created)
                 return;
             gtk_list_store_clear(m_refListModel);
        }

        void delete_item(int position) {
            //Gtk::TreePath path;
            //path.append_index(position);
            GtkTreeIter iter;
            GtkTreeModel *model=gtk_combo_box_get_model(GTK_COMBO_BOX(handle));

            GtkTreePath *path=gtk_tree_path_new();
            gtk_tree_path_append_index(path, position);
            gtk_tree_model_get_iter (model, &iter, path);

            gtk_list_store_remove(GTK_LIST_STORE (model), &iter);
            //m_refListModel->erase(m_refListModel->get_iter(path));
            gtk_tree_path_free(path);
        }

        void update_item(AnsiString *value) {
            position=0;
            AnsiString *POST_STRINGS=this->POST_STRINGS;
            if (*value==(char *)"-1")
                *value=(char *)"";

            //Gtk::TreeModel::Row row;

            //row = *(m_refListModel->get_iter((Glib::ustring)value->c_str()));
            GtkTreeIter iter;
            GtkTreeModel *model=gtk_combo_box_get_model(GTK_COMBO_BOX(handle));

            GtkTreePath *path=gtk_tree_path_new();
            gtk_tree_path_append_index(path, value->ToInt());
            gtk_tree_model_get_iter (model, &iter, path);
            gtk_tree_path_free(path);


            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //gtk_list_store_set_value(m_refListModel, &iter, i, gv);
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        GdkPixbuf *pbuf=ForcePixbuf(ctrl);
                        gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, pbuf, -1);
                    }
                    no_ctl=true;
                    //row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
                }
                if (!no_ctl)
                    gtk_list_store_set_value(m_refListModel, &iter, i, &gval);
            }
        }

        void add_item(int insert_position=-1) {
            if (!created)
                create_model();

            position=0;
            //Gtk::TreeModel::Row row;
            GtkTreeIter iter;

            if (insert_position<0)
                gtk_list_store_append(m_refListModel, &iter);
            else {
                gtk_list_store_insert(m_refListModel, &iter, insert_position);
            }
            
            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //gtk_list_store_set_value(m_refListModel, &iter, i, gv);
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        GdkPixbuf *pbuf=ForcePixbuf(ctrl);
                        gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, pbuf, -1);
                    }
                    no_ctl=true;
                    //row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
                }
                if (!no_ctl)
                    gtk_list_store_set_value(m_refListModel, &iter, i, &gval);
            }
        }


        void add_column(/*char *column_name*/int col_type=0) {
            GtkCellRenderer *cell=NULL;
            if (col_type==2) {
                cell = gtk_cell_renderer_progress_new();

                columns[columns_count].type=col_type;
                columns[columns_count].ptr=cell;
                columns_count++;

                gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, TRUE );
                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "value", columns_count-1,
                                    NULL );
            } else
            if (col_type==5) {
                cell = gtk_cell_renderer_pixbuf_new();

                columns[columns_count].type=col_type;
                columns[columns_count].ptr=cell;
                columns_count++;

                gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, FALSE );
                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "pixbuf", columns_count-1,
                                    NULL );
            } else {
                if (col_type!=0)
                    cell = gtk_cell_renderer_text_new();

                columns[columns_count].type=0;
                columns[columns_count].ptr=cell;
                columns_count++;

                if (col_type!=0) {
                    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, TRUE );

                    //g_object_set_data(G_OBJECT(G_OBJECT(cell)), "column", GINT_TO_POINTER (columns_count-1));

                    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(handle), cell,
                                        "text", columns_count-1,
                                        //"visible", (gboolean)(col_type!=0),
                                        NULL );
                }
            }
        }

        void add_columns(int columns, int type=0) {
            for (int i=0;i<columns;i++)
                add_column(type);
        }

        void clear_all() {
            clear_items();
            columns_count=0;
            position=0;
            created=0;
        }
};


/*class DeturnatedComboBox : public Gtk::ComboBox {
    public:
        GtkWidget *handle;
    private:
        DeturnatedColumn columns[MAX_COLUMNS];
        int columns_count;
        int position;
        AnsiString POST_STRINGS[MAX_COLUMNS];
        
        Glib::RefPtr<Gtk::ListStore> m_refListModel;
        char created;

        Gtk::TreeModel::ColumnRecord crecord;
    public:

        DeturnatedComboBox() {
            // nothing ...
            columns_count=0;
            position=0;
            created=0;
            handle=gtk_combo_box_new();
        }

        ~DeturnatedComboBox() {
            for (int i=0;i<columns_count;i++) {
                    if (columns[i].type==1) 
                        delete (Gtk::TreeModelColumn<double> *)columns[i].ptr;
                    if (columns[i].type==2) 
                        delete (Gtk::TreeModelColumn<bool> *)columns[i].ptr;
                    else
                        delete (Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr;
            }
        }



        void post_string(AnsiString s) {
            POST_STRINGS[position++]=s;
        }

        void create_model() {
            created=1;
            m_refListModel=Gtk::ListStore::create(crecord);
            set_model(m_refListModel);
        }

        void clear_items() {
             if (!created)
                 return;
             m_refListModel->clear();
        }

        void delete_item(int position) {
            Gtk::TreePath path;
            path.append_index(position);
                    
            m_refListModel->erase(m_refListModel->get_iter(path));
        }


        void update_item(AnsiString *value) {
            position=0;
            AnsiString *POST_STRINGS=this->POST_STRINGS;
            if (*value==(char *)"-1")
                *value=(char *)"";

            Gtk::TreeModel::Row row;

            row = *(m_refListModel->get_iter((Glib::ustring)value->c_str()));

            for (int i=0;i<columns_count;i++) {
                if (columns[i].type==1) {
                    row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr]=POST_STRINGS[i].c_str();
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    Gtk::Image *ctrl=GetImageID(ctrlID);
                    if (ctrl)
                        row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();
                } else
                if (columns[i].type==6) {
                    row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr2]=POST_STRINGS[i].c_str();
                    POST_STRINGS++;
                    int ctrlID=POST_STRINGS[i].ToInt();
                    Gtk::ComboBox *ctrl=GetComboID(ctrlID);
                    if (ctrl) {
                        row[*(Gtk::TreeModelColumn< Glib::RefPtr<Gtk::TreeModel> > *)columns[i].ptr]=ctrl->get_model();
                    }
                } else
                    row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
            }
        }

        void add_item(int insert_position=-1) {
            if (!created)
                create_model();

            position=0;
            Gtk::TreeModel::Row row;
            if (insert_position<0)
                row= *(m_refListModel->append());
            else {
                Gtk::TreePath path;
                path.append_index(insert_position);
                row= *(m_refListModel->insert(m_refListModel->get_iter(path)));
            }
            
            for (int i=0;i<columns_count;i++) {
                if (columns[i].type==2) {
                    row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==0) {
                    row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr]=POST_STRINGS[i].c_str();
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    Gtk::Image *ctrl=GetImageID(ctrlID);
                    if (ctrl)
                        row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();
                } else
                    row[*(Gtk::TreeModelColumn<bool> *)columns[i].ptr]=(bool)POST_STRINGS[i].ToInt();
            }
        }

        void add_column(int col_type=0) {

            if (col_type==2) {
                Gtk::TreeModelColumn<double> *column=new Gtk::TreeModelColumn<double>;
                columns[columns_count].type=col_type;
                columns[columns_count].ptr=column;
                columns_count++;
                crecord.add(*column);

                Gtk::CellRendererProgress cell;
                pack_start(cell);
                add_attribute(cell, "value", columns_count-1);
            } else
            if (col_type==5) {
                Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *column=new Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> >;
                columns[columns_count].type=col_type;
                columns[columns_count].ptr=column;
                columns_count++;

                crecord.add(*column);
                Gtk::CellRendererPixbuf cell;
                pack_start(cell);
                add_attribute(cell, "pixbuf", columns_count-1);
            } else {
                Gtk::TreeModelColumn<Glib::ustring> *column=new Gtk::TreeModelColumn<Glib::ustring>;
                columns[columns_count].type=0;
                columns[columns_count].ptr=column;
                columns_count++;
                crecord.add(*column);
                pack_start(*column);
            }
        }

        void add_columns(int columns, int type=0) {
            for (int i=0;i<columns;i++)
                add_column(type);
        }

        void clear_all() {
            clear();
            columns_count=0;
            position=0;
            created=0;
        }
};
*/

//typedef void (*HeaderClickCallback)(ClientEventHandler *HANDLER);
void my_header_event(void *EVENT_HANDLER);

class DeturnatedTreeView/* : public Gtk::TreeView*/ {
    friend class ClientEventHandler;
    public:
        GtkWidget *handle;
    private:
        int position;
        char column_events;
        AnsiString POST_STRINGS[MAX_COLUMNS];
        
        GtkListStore *m_refListModel;
        GtkTreeStore *m_refTreeModel;
        char type;
        char created;

        //void *EVENT_HANDLER;

        GdkColor even_color;
        GdkColor odd_color;

        bool alternate;
    public:
        //HeaderClickCallback click_cb;
        void *EVENT_HANDLER;

        DeturnatedColumn columns[MAX_COLUMNS];
        int columns_count;

        static gboolean signal_header_clicked(void *Sender, void *THIS_REF);

        GdkColor *GetColor(long color, GdkColor *uset_color) {
                int red=color/0x10000;
                color%=0x10000;
                int green=color/0x100;
                color%=0x100;
                int blue=color;
                uset_color->red=((unsigned short)red*0xFF);
                uset_color->green=((unsigned short)green*0xFF);
                uset_color->blue=((unsigned short)blue*0xFF);
                return uset_color;
        }

        void SetColors(long even, long odd) {
            if ((even==-1) || (odd==-1)) {
                alternate=false;
                return;
            }

            alternate=true;
            GetColor(even, &even_color);
            GetColor(odd, &odd_color);
        }

        static void on_cell_data(GtkTreeViewColumn *tree_column, GtkCellRenderer *cell, GtkTreeModel *tree_model, GtkTreeIter *iter, gpointer THIS_REF);

        DeturnatedTreeView()/* : TreeView()*/ {
            // nothing ...
            columns_count=0;
            type=-1;
            position=0;
            created=0;
            column_events=0;
            EVENT_HANDLER=0;
            alternate=false;
            handle=gtk_tree_view_new();
        }

        ~DeturnatedTreeView() {
            /*for (int i=0;i<columns_count;i++) {
                    if (columns[i].type==1) 
                        delete (Gtk::TreeModelColumn<double> *)columns[i].ptr;
                    if (columns[i].type==2) 
                        delete (Gtk::TreeModelColumn<bool> *)columns[i].ptr;
                    else
                        delete (Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr;
            }*/
        }

        void post_string(AnsiString s) {
            POST_STRINGS[position++]=s;
        }

        void deturnated_set_model(char value) {
            type=value;
        }

        void register_renders() {
            int real_index=-1;
            for (int i=0;i<columns_count;i++) {
                //Gtk::CellRenderer* render = get_column_cell_renderer(i);
                GtkCellRenderer *render = (GtkCellRenderer *)columns[i].ptr;
                if (columns[i].type!=-1)
                    real_index++;
                if (render) {
                    GtkTreeViewColumn *column=gtk_tree_view_get_column(GTK_TREE_VIEW(handle), /*i*/real_index);
                    //std::cerr << "PRE: " << real_index << "/" << i << "\n";
                    gtk_tree_view_column_set_cell_data_func(column, render, DeturnatedTreeView::on_cell_data, this, NULL);
                    //std::cerr << "POST: " << real_index << "/" << i << "\n";
                }
            }
        }

        void create_model() {
            created=1;
            GType *elems=new GType[columns_count];
            for (int i=0;i<columns_count;i++) {
                switch (columns[i].type) {
                    case 2://progress
                            elems[i]=G_TYPE_INT;
                            break;
                    case 1://property
                            elems[i]=G_TYPE_BOOLEAN;
                            break;
                    case 0://string
                            elems[i]=G_TYPE_STRING;
                            break;
                    case 5://pixbuf
                            elems[i]=GDK_TYPE_PIXBUF;
                            break;
                    case 6://combo
                            elems[i]=G_TYPE_STRING;
                            break;
                    case -1://combo model !
                            elems[i]=GTK_TYPE_TREE_MODEL;
                            break;
                    default: //bool
                            elems[i]=G_TYPE_BOOLEAN;
                            break;
                }
            }
            switch (type) {
                    case 0:
                        m_refListModel=gtk_list_store_newv(columns_count, elems);
                        gtk_tree_view_set_model(GTK_TREE_VIEW(handle), GTK_TREE_MODEL(m_refListModel));
                        break;
                    case 1:
                        m_refTreeModel=gtk_tree_store_newv(columns_count, elems);
                        gtk_tree_view_set_model(GTK_TREE_VIEW(handle), GTK_TREE_MODEL(m_refTreeModel));
                        break;
            }
            delete[] elems;
            register_renders();
        }

        void clear() {
            if (!created) // partea cu created e adaugata de curand
                return;

            if (type==0) 
                gtk_list_store_clear(m_refListModel);
            else
                gtk_tree_store_clear(m_refTreeModel);
        }

        void delete_item(AnsiString *pathstr) {
            /*Gtk::TreePath path;
            path.append_index(position);*/
            //std::cout << "Delete\n";
                    
            /*if (type==0)
                m_refListModel->erase(m_refListModel->get_iter(path->c_str()));
            else
                m_refTreeModel->erase(m_refTreeModel->get_iter(path->c_str()));*/
            //std::cout << "done delete\n";

            GtkTreeIter iter;
            GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(handle));

            GtkTreePath *path=gtk_tree_path_new_from_string(pathstr->c_str());
            gtk_tree_model_get_iter (model, &iter, path);

            if (type==0) 
                gtk_list_store_remove(GTK_LIST_STORE(model), &iter);
            else
                gtk_tree_store_remove(GTK_TREE_STORE(model), &iter);

            gtk_tree_path_free(path);
        }

        void update_item(AnsiString *value) {
            position=0;
            AnsiString *POST_STRINGS=this->POST_STRINGS;
            if (*value==(char *)"-1")
                *value=(char *)"";

            GtkTreeIter iter;
            GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(handle));

            /*GtkTreePath *path=gtk_tree_path_new();
            gtk_tree_path_append_index(path, position);
            gtk_tree_model_get_iter (model, &iter, path);
            gtk_tree_path_free(path);*/
            GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
            gtk_tree_model_get_iter (model, &iter, path);
            gtk_tree_path_free(path);

            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                int target_i=i;
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==1) {
                    g_value_init(&gval, G_TYPE_DOUBLE);
                    g_value_set_double(&gval, POST_STRINGS[i].ToInt());
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                    //row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr]=POST_STRINGS[i].c_str();
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        //g_value_init(&gval, GDK_TYPE_PIXBUF);
                        //g_value_set_pixbuf(&gval, ForcePixbuf(ctrl));
                        if (type==0)
                            gtk_list_store_set(GTK_LIST_STORE(model), &iter, i, ForcePixbuf(ctrl), -1);
                        else
                            gtk_tree_store_set(GTK_TREE_STORE(model), &iter, i, ForcePixbuf(ctrl), -1);
                    } //else
                        no_ctl=true;
                    /*int ctrlID=POST_STRINGS[i].ToInt();
                    Gtk::Image *ctrl=GetImageID(ctrlID);
                    if (ctrl)
                        row[*(Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > *)columns[i].ptr]=Glib::wrap(ForcePixbuf(ctrl));//ctrl->get_pixbuf();*/
                } else
                if (columns[i].type==6) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                    i++;

                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkComboBox *ctrl=GetComboID(ctrlID);
                    if (ctrl) {
                        if (type==0)
                            gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, gtk_combo_box_get_model(ctrl), -1);
                        else
                            gtk_tree_store_set(GTK_TREE_STORE(m_refTreeModel), &iter, i, gtk_combo_box_get_model(ctrl), -1);
                    }
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                }
                if (!no_ctl) {
                    if (type==0) 
                        gtk_list_store_set_value(GTK_LIST_STORE(model), &iter, target_i, &gval);
                    else
                        gtk_tree_store_set_value(GTK_TREE_STORE(model), &iter, target_i, &gval);
                }
            }
        }

        void add_child_item(AnsiString *target, AnsiString *value) {
            int insert_position=target->ToInt();
            position=0;
            AnsiString *POST_STRINGS=this->POST_STRINGS;
            if (type==1) {
                if (*value==(char *)"-1")
                    *value=(char *)"";

                GtkTreeIter iter;
                GtkTreeIter iter2;
                GtkTreeIter iter3;
                GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(handle));

                if (*value==(char *)"")
                    if (insert_position<0) {
                        gtk_tree_store_append(m_refTreeModel, &iter, NULL);
                    } else {
                        //Gtk::TreePath path;

                        /*GtkTreePath *path=gtk_tree_path_new();
                        gtk_tree_path_append_index(path, insert_position);
                        gtk_tree_model_get_iter (model, &iter2, path);
                        gtk_tree_store_insert_before(m_refTreeModel, &iter, &iter2, NULL);
                        gtk_tree_path_free(path);*/
                        gtk_tree_store_insert(m_refTreeModel, &iter, NULL, insert_position);
                        //path.append_index(insert_position);
                        //row= *(m_refTreeModel->insert(m_refTreeModel->get_iter(path)));
                    }
                else {
                    //std::cout << "Path: " << value->c_str() << "\n";
                    //row = *(m_refTreeModel->get_iter((Glib::ustring)value->c_str()));
                    GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
                    gtk_tree_model_get_iter(model, &iter2, path);

                    if (insert_position<0) {
                        // daca target = -1, atunci adaug la copii ...
                        //row = *(m_refTreeModel->append(row.children()));
                        gtk_tree_store_insert_before(m_refTreeModel, &iter, &iter2, NULL);
                    } else {
                        //row = *(m_refTreeModel->insert(row.children()[insert_position]));
                        /*GtkTreePath *path2=gtk_tree_path_new();
                        gtk_tree_path_append_index(path2, insert_position);
                        gtk_tree_model_get_iter(model, &iter3, path2);
                        gtk_tree_path_free(path2);*/

                        //gtk_tree_path_append_index(path, insert_position);

                        gtk_tree_model_get_iter(model, &iter3, path);
                        //gtk_tree_store_insert_before(m_refTreeModel, &iter, NULL/*&iter2*/, &iter3);
                        gtk_tree_store_insert(m_refTreeModel, &iter, &iter3, insert_position);
                    }
                    gtk_tree_path_free(path);
                }

                for (int i=0;i<columns_count;i++) {
                    GValue gval = {0,};
                    int target_i=i;
                    bool no_ctl=false;
                    if (columns[i].type==2) {
                        g_value_init(&gval, G_TYPE_INT);
                        g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                        //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                    } else
                    if (columns[i].type==1) {
                        g_value_init(&gval, G_TYPE_DOUBLE);
                        g_value_set_double(&gval, POST_STRINGS[i].ToInt());
                    } else
                    if (columns[i].type==0) {
                        g_value_init(&gval, G_TYPE_STRING);
                        g_value_set_string(&gval, POST_STRINGS[i].c_str());
                        //row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr]=POST_STRINGS[i].c_str();
                    } else
                    if (columns[i].type==5) {
                        int ctrlID=POST_STRINGS[i].ToInt();
                        GtkImage *ctrl=GetImageID(ctrlID);
                        if (ctrl) {
                           gtk_tree_store_set(GTK_TREE_STORE(m_refTreeModel), &iter, i, ForcePixbuf(ctrl), -1);
                        }
                        no_ctl=true;
                    } else
                    if (columns[i].type==6) {
                        g_value_init(&gval, G_TYPE_STRING);
                        g_value_set_string(&gval, POST_STRINGS[i].c_str());
                        i++;

                        int ctrlID=POST_STRINGS[i].ToInt();
                        GtkComboBox *ctrl=GetComboID(ctrlID);
                        if (ctrl)
                            gtk_tree_store_set(GTK_TREE_STORE(m_refTreeModel), &iter, i, gtk_combo_box_get_model(ctrl), -1);
                    } else {

                        g_value_init(&gval, G_TYPE_BOOLEAN);
                        g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                    }
                    if (!no_ctl)
                        gtk_tree_store_set_value(GTK_TREE_STORE(m_refTreeModel), &iter, target_i, &gval);
                }
            }
        }

        void add_item(AnsiString *value) {
            AnsiString *POST_STRINGS=this->POST_STRINGS;

            if (!created)
                create_model();

            position=0;
            int insert_position=value->ToInt();
            GtkTreeIter iter;

            GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(handle));

            if (type==0) {
                if (insert_position<0)
                    gtk_list_store_append(m_refListModel, &iter);
                else {
                    gtk_list_store_insert(m_refListModel, &iter, insert_position);
                }
            } else {
                //row = *(m_refTreeModel->get_iter((Glib::ustring)value->c_str()));
                  //row = *(m_refTreeModel->append(row.children()));
                //row = *(m_refTreeModel->insert(row));

                if (insert_position<0)
                    gtk_tree_store_append(m_refTreeModel, &iter, NULL);
                else {
                    GtkTreeIter iter2;
                    GtkTreePath *path=gtk_tree_path_new_from_string(value->c_str());
                    gtk_tree_model_get_iter(model, &iter2, path);
                    /*if (!gtk_tree_model_iter_children(model, &iter, &iter2))
                        gtk_tree_model_get_iter(model, &iter, path);*/

                    //gtk_tree_store_append(m_refTreeModel, &iter, &iter2);
                    //gtk_tree_store_insert(m_refTreeModel, &iter, insert_position);

                    gtk_tree_store_insert_before(m_refTreeModel, &iter, NULL, &iter2);
                    gtk_tree_path_free(path);
                }
            }
            
            for (int i=0;i<columns_count;i++) {
                GValue gval = {0,};
                int target_i=i;
                bool no_ctl=false;
                if (columns[i].type==2) {
                    g_value_init(&gval, G_TYPE_INT);
                    g_value_set_int(&gval, POST_STRINGS[i].ToInt());
                    //row[*(Gtk::TreeModelColumn<double> *)columns[i].ptr]=POST_STRINGS[i].ToFloat();
                } else
                if (columns[i].type==1) {
                    g_value_init(&gval, G_TYPE_DOUBLE);
                    g_value_set_double(&gval, POST_STRINGS[i].ToInt());
                } else
                if (columns[i].type==0) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                    //row[*(Gtk::TreeModelColumn<Glib::ustring> *)columns[i].ptr]=POST_STRINGS[i].c_str();
                } else
                if (columns[i].type==5) {
                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkImage *ctrl=GetImageID(ctrlID);
                    if (ctrl) {
                        GdkPixbuf *pbuf=ForcePixbuf(ctrl);
                        if (type==0)
                            gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, pbuf, -1);
                        else
                            gtk_tree_store_set(GTK_TREE_STORE(m_refTreeModel), &iter, i, ForcePixbuf(ctrl), -1);
                    }
                    no_ctl=true;
                } else
                if (columns[i].type==6) {
                    g_value_init(&gval, G_TYPE_STRING);
                    g_value_set_string(&gval, POST_STRINGS[i].c_str());
                    i++;

                    int ctrlID=POST_STRINGS[i].ToInt();
                    GtkComboBox *ctrl=GetComboID(ctrlID);
                    if (ctrl) {
                        if (type==0)
                            gtk_list_store_set(GTK_LIST_STORE(m_refListModel), &iter, i, gtk_combo_box_get_model(ctrl), -1);
                        else
                            gtk_tree_store_set(GTK_TREE_STORE(m_refTreeModel), &iter, i, gtk_combo_box_get_model(ctrl), -1);
                    }
                } else {
                    g_value_init(&gval, G_TYPE_BOOLEAN);
                    g_value_set_boolean(&gval, (gboolean)POST_STRINGS[i].ToInt());
                }
                if (!no_ctl) {
                    if (type==0) 
                        gtk_list_store_set_value(GTK_LIST_STORE(m_refListModel), &iter, target_i, &gval);
                    else
                        gtk_tree_store_set_value(GTK_TREE_STORE(m_refTreeModel), &iter, target_i, &gval);
                }
            }
        }

        int GetColumnIndex(GtkTreeViewColumn *column) {
            for (int i=0;i<columns_count;i++) {
                 GtkTreeViewColumn *t_column=gtk_tree_view_get_column(GTK_TREE_VIEW(handle), i);
                 if (t_column==column)
                     return i;
            }
            return -1;
        }

        GtkTreeViewColumn *GetColumn(int index) {
            return gtk_tree_view_get_column(GTK_TREE_VIEW(handle), index);
        }

        GtkTreeViewColumn *get_column(int index) {
            return GetColumn(index);
        }

		int add_custom(int index, AnsiString attr_name) {
            GtkTreeViewColumn* pColumn    =   get_column(index);
			if (pColumn) {
				if ((attr_name==(char*)"foreground") ||
                    (attr_name==(char*)"background") ||
                    (attr_name==(char*)"font") ||
                    (attr_name==(char*)"family") ||
                    (attr_name==(char*)"language") ||
                    (attr_name==(char*)"markup")) {

                    //GtkCellRenderer *cell=gtk_cell_renderer_text_new();

					columns[columns_count].type=0;
					columns[columns_count].ptr=0;//cell;
					columns[columns_count].events=0;
					columns_count++;
					
                    GList *lst=gtk_tree_view_column_get_cell_renderers(pColumn);
                    GtkCellRenderer *cell=GTK_CELL_RENDERER(lst->data);
                    if (lst)
                        g_list_free(lst);

                    gtk_tree_view_column_add_attribute(pColumn, cell, attr_name, columns_count-1);
				}
                 else
				if ((attr_name==(char*)"editable") || 
                    (attr_name==(char*)"strikethrough")) {
					columns[columns_count].type=3;
					columns[columns_count].ptr=0;
					columns[columns_count].events=0;
					columns_count++;

                    GList *lst=gtk_tree_view_column_get_cell_renderers(pColumn);
                    GtkCellRenderer *cell=GTK_CELL_RENDERER(lst->data);
                    if (lst)
                        g_list_free(lst);

                    gtk_tree_view_column_add_attribute(pColumn, cell, attr_name, columns_count-1);
				} else
				if ((attr_name==(char*)"ellipsize") ||
				    (attr_name==(char*)"alignment") ||
                    (attr_name==(char*)"style") ||
                    (attr_name==(char*)"rise") ||
                    (attr_name==(char*)"size") ||
                    (attr_name==(char*)"scale")) {
					columns[columns_count].type=1;
					columns[columns_count].ptr=0;
					columns[columns_count].events=0;
					columns_count++;
					//crecord.add(*column);

                    GList *lst=gtk_tree_view_column_get_cell_renderers(pColumn);
                    GtkCellRenderer *cell=GTK_CELL_RENDERER(lst->data);
                    if (lst)
                        g_list_free(lst);

                    gtk_tree_view_column_add_attribute(pColumn, cell, attr_name, columns_count-1);
				} else
					return 0;
				return 1;
			}
			return 0;
		}

        void add_column(char *column_name, char visible=0, char editable=0) {
            //Gtk::TreeModelColumn<Glib::ustring> *column=new Gtk::TreeModelColumn<Glib::ustring>;
            //columns[columns_count]=new DeturnatedColumn;
            GtkCellRenderer *cell=NULL;
            cell = gtk_cell_renderer_text_new();

            columns[columns_count].type=0;
            columns[columns_count].ptr=cell;
            columns[columns_count].events=0;
            columns_count++;
            //crecord.add(*column);
            //if (visible) {
                /*gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(handle), cell, FALSE );

                gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT(handle), cell,
                                    "text", columns_count-1,
                                    NULL );*/
                g_object_set_data (G_OBJECT (cell), "column", GINT_TO_POINTER (columns_count-1));
                if (editable)
                    g_object_set (cell, "editable", TRUE, NULL);

                if (!visible)
                    g_object_set (cell, "visible", FALSE, NULL);

                gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (handle),
                                           -1, column_name, cell,
                                           "text", columns_count-1,
                                           NULL);
                    //append_column((Glib::ustring)column_name,*column);
            //}

            /*if ((EVENT_HANDLER) && (column_events)) {
                char events=column_events;
                column_events=0;
                ((ClientEventHandler *)(EVENT_HANDLER))->refresh_events(this, events);
            }*/
        }

        void add_column_image(char *column_name) {
            GtkCellRenderer *cell=gtk_cell_renderer_pixbuf_new();
            columns[columns_count].type=5;
            columns[columns_count].ptr=cell;
            columns[columns_count].events=0;
            columns_count++;

            g_object_set_data (G_OBJECT (cell), "column", GINT_TO_POINTER (columns_count-1));
            gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (handle),
                                       -1, column_name, cell,
                                       "pixbuf", columns_count-1,
                                       NULL);

            /*int cols_count                  =   gtk_tree_view_insert_column_with_attributes(
                                                    GTK_TREE_VIEW (handle),
                                                    -1, column_name, cell,
                                                    NULL);

            GtkTreeViewColumn* pColumn    =   get_column(cols_count - 1);

            if (pColumn) {
                gtk_tree_view_column_add_attribute(pColumn, cell, "pixbuf", cols_count - 1);
                //pColumn->add_attribute(cell.property_pixbuf(), *column);
            }*/
        }

        int adjust_column(int index) {
            int result=0;
            if (index<columns_count) {
                for (int i=0;i<columns_count;i++) {
                    if (columns[i].type>=0) {
                        //if (index==result)
                        if (i>=index)
                            return result;
                        else
                            result++;
                    }
                }
                return result;
            }
            return result;
        }

        int adjust_column2(int index) {
            int result=0;
            if (index<columns_count) {
                for (int i=0;i<columns_count;i++) {
                    if (columns[i].type>=0) {
                        //if (index==result)
                        if (i>=index)
                            return result;
                    } else
                        index++;
                    result++;
                }
                return result;
            }
            return result;
        }

        void add_column_combo(char *column_name, bool editable=false) {
            GtkCellRenderer *cell = gtk_cell_renderer_combo_new();

            columns[columns_count].type=6;
            columns[columns_count].ptr=cell;
            columns[columns_count].events=0;
            columns_count++;

            g_object_set (cell,
                        "text-column", 0,
                        "has-entry", FALSE,
                        "editable", editable,
                        NULL);

            g_object_set_data (G_OBJECT (cell), "column", GINT_TO_POINTER (columns_count-1));

			columns[columns_count].type=-1;
			columns[columns_count].ptr=0;
			columns[columns_count].events=0;
			columns_count++;

            gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (handle),
                                       -1, column_name, cell,
                                       "text", columns_count-2,
                                       "model", columns_count-1,
                                       NULL);

            /*Gtk::TreeModelColumn< Glib::RefPtr<Gtk::TreeModel> > *column=new Gtk::TreeModelColumn< Glib::RefPtr<Gtk::TreeModel> >;
            Gtk::TreeModelColumn<Glib::ustring> *column2=new Gtk::TreeModelColumn<Glib::ustring>;

            columns[columns_count].type=6;
            columns[columns_count].ptr=column;
            columns[columns_count].ptr2=column2;
            columns_count++;
            //crecord.add(*column2);
            //crecord.add(*column);

            Gtk::CellRendererCombo cell;
            cell.property_has_entry()=editable;
            cell.property_editable() = true;
            cell.property_text_column() = 0;
            //cell.property_model()=model;

            int cols_count                  =   append_column((Glib::ustring)column_name, cell);
            Gtk::TreeViewColumn* pColumn    =   get_column(cols_count - 1);

            if (pColumn) {
                //pColumn->pack_start(cell);
                pColumn->add_attribute(cell.property_model(), *column);
                pColumn->add_attribute(cell.property_text(), *column2);
            }
            */

        }

        /*void add_column_combo(char *column_name, bool editable=false, int textcolumn=0,) {
            if ((textcolumn<0) || (text_column>=columns_count)) {
                std::cerr << "DEBUG: add_column_combo> invalid target column\n";
                return;
            }

            Gtk::TreeModelColumn< Glib::RefPtr<Gtk::TreeModel> > *column=new Gtk::TreeModelColumn< Glib::RefPtr<Gtk::TreeModel> >;
            columns[columns_count].type=6;
            columns[columns_count].ptr=column;
            columns_count++;
            crecord.add(*column);

            Gtk::CellRendererCombo cell;
            cell.property_has_entry()=editable;
            cell.property_text_column()=0;

            int cols_count                  =   append_column((Glib::ustring)column_name, cell);
            Gtk::TreeViewColumn* pColumn    =   get_column(cols_count - 1);

            if (pColumn) {
                //pColumn->pack_start(cell);
                pColumn->add_attribute(cell.property_model(), *column);
                pColumn->add_attribute(cell.property_text(), *column);
            }

        }*/

        void add_column_bool(char *column_name, char visible, char editable=0) {
            GtkCellRenderer *cell=NULL;
            cell = gtk_cell_renderer_toggle_new();

            columns[columns_count].type=visible;
            columns[columns_count].ptr=cell;
            columns[columns_count].events=0;
            columns_count++;
            //crecord.add(*column);

            g_object_set (GTK_CELL_RENDERER_TOGGLE(cell),
                        "radio", (gboolean)(visible==4),
                        "activatable", (gboolean)(editable!=0),
                        NULL);
            g_object_set_data (G_OBJECT (cell), "column", GINT_TO_POINTER (columns_count-1));
            gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (handle),
                                       -1, column_name, cell,
                                       "active", columns_count-1,
                                       NULL);
            /*Gtk::TreeModelColumn<bool> *column=new Gtk::TreeModelColumn<bool>;
            columns[columns_count].type=visible;
            columns[columns_count].ptr=column;
            columns_count++;
            //crecord.add(*column);

            Gtk::CellRendererToggle cell;
            if (editable)
                cell.property_activatable()=true;
            int cols_count                  =   append_column((Glib::ustring)column_name, cell);
            Gtk::TreeViewColumn* pColumn    =   get_column(cols_count - 1);

            if (pColumn) {
                if (visible==4) {
                    cell.set_radio(true);
                    cell.property_radio()=true;
                }
                pColumn->add_attribute(cell.property_active(), *column);
            }*/
        }

        void remove_column_by_index(int index) {
            if ((index>=0) && (index<columns_count)) {
                gtk_tree_view_remove_column(GTK_TREE_VIEW(handle), get_column(index));
                columns_count--;
                // to do !
                //delete columns[columns_count].ptr;
                for (int i=index;i<columns_count;i++) {
                    columns[i].type     =   columns[i+1].type;
                    columns[i].ptr      =   columns[i+1].ptr;
                    columns[i].events   =   columns[i+1].events;
                    //columns[i].ptr2     =   columns[i+1].ptr2;
                }
            }
        }

        void clear_columns() {
            while (columns_count)
                remove_column_by_index(0);
            columns_count=0;
            created=0;
        }

        void add_column_number(char *column_name, char *format=0, char visible=0, char editable=0) {
            if ((visible==3) || (visible==4)) {
                add_column_bool(column_name, visible, editable);
                return;
            }
            GtkCellRenderer *cell=NULL;
            cell = gtk_cell_renderer_progress_new();

            columns[columns_count].type=visible;
            columns[columns_count].ptr=cell;
            columns[columns_count].events=0;
            columns_count++;

            g_object_set_data (G_OBJECT (GTK_CELL_RENDERER_PROGRESS(cell)), "column", GINT_TO_POINTER (columns_count-1));
            gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (handle),
                                       -1, column_name, cell,
                                       "value", columns_count-1,
                                       NULL);
/*
            Gtk::TreeModelColumn<double> *column=new Gtk::TreeModelColumn<double>;
            //columns[columns_count]=new DeturnatedColumn;
            columns[columns_count].type=1;
            columns[columns_count].ptr=column;
            columns_count++;
            //crecord.add(*column);
            if (visible) {
                if ((format) && (format[0])) {
                    if (editable)
                        append_column_numeric_editable((Glib::ustring)column_name,*column,(Glib::ustring)format);
                    else
                        append_column_numeric((Glib::ustring)column_name,*column,(Glib::ustring)format);
                } else {
                    switch (visible) {
                        case 2:
                            {
                                Gtk::CellRendererProgress cell;
                                int cols_count                  =   append_column((Glib::ustring)column_name, cell);
                                Gtk::TreeViewColumn* pColumn    =   get_column(cols_count - 1);

                                if (pColumn) {
                                    pColumn->add_attribute(cell.property_value(), *column);
                                }
                            }
                            break;
                    }
                }
            }*/
        }
};

#endif
