#include "inputform.h"

InputDialog::InputDialog(char *title, bool password) {
        handle=GTK_DIALOG(gtk_dialog_new_with_buttons(title, NULL, GTK_DIALOG_MODAL, GTK_STOCK_OK, GTK_RESPONSE_OK, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL));

        UserLabel=GTK_LABEL(gtk_label_new(title));
        gtk_widget_show(GTK_WIDGET(UserLabel));
        UserEntry=GTK_ENTRY(gtk_entry_new());
        gtk_widget_show(GTK_WIDGET(UserEntry));

        GtkVBox *box=GTK_VBOX(gtk_dialog_get_content_area(handle));
		
        gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(UserLabel), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(UserEntry), TRUE, TRUE, 0);
        gtk_entry_set_activates_default(UserEntry, TRUE);

        gtk_entry_set_visibility(UserEntry, !password);
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
        g_object_set(G_OBJECT(UserEntry), "caps-lock-warning", TRUE, NULL);
#endif

        gtk_window_set_keep_above(GTK_WINDOW(handle), true);

        gtk_widget_set_size_request(GTK_WIDGET(UserLabel), 200, -1);
        gtk_window_set_position(GTK_WINDOW(handle), GTK_WIN_POS_CENTER_ON_PARENT);
		gtk_dialog_set_default_response(handle, GTK_RESPONSE_OK);
        //gtk_widget_show_all(GTK_WIDGET(handle));
}

void InputDialog::reset(char *text, char *hint, bool password) {
    gtk_entry_set_text(UserEntry, text);
    gtk_entry_set_visibility(UserEntry, !password);
    if (!gtk_label_get_use_markup(UserLabel))
        gtk_label_set_use_markup(UserLabel, true);
    gtk_label_set_markup(UserLabel, hint);
    gtk_window_set_modal(GTK_WINDOW(handle), TRUE);
    gtk_widget_grab_focus(GTK_WIDGET(UserEntry));
}

void InputDialog::hide() {
    gtk_widget_hide(GTK_WIDGET(handle));
}

int InputDialog::run() {
    return gtk_dialog_run(handle);
}

AnsiString InputDialog::GetText() {
    return AnsiString((char *)gtk_entry_get_text(UserEntry));
}

InputDialog::~InputDialog() {
}

