#include "splash.h"
#include "AnsiString.h"
#include "ConceptClient.h"


SplashWindow::SplashWindow(AnsiString image_path) {
    //set_auto_startup_notification(false);
    seminit(sem_lock, 1);

    handle=GTK_WINDOW(gtk_dialog_new());
    gtk_window_set_title(handle,"Loading ...");
    gtk_window_set_resizable(handle,false);
    gtk_window_set_decorated(handle,false);
    gtk_window_set_position(handle,GTK_WIN_POS_CENTER);

    GtkVBox *box=GTK_VBOX(gtk_dialog_get_content_area(GTK_DIALOG(handle)));
    gtk_dialog_set_has_separator(GTK_DIALOG(handle), FALSE);
    gtk_widget_hide(GTK_WIDGET(gtk_dialog_get_action_area(GTK_DIALOG(handle))));

    //gtk_container_add(GTK_CONTAINER(handle), GTK_WIDGET(box));

    pb=GTK_PROGRESS_BAR(gtk_progress_bar_new());

    GtkImage *img=GTK_IMAGE(gtk_image_new());
    gtk_image_set_from_file(img, image_path.c_str());

    gtk_container_add(GTK_CONTAINER(box), GTK_WIDGET(img));

    gtk_container_add(GTK_CONTAINER(box), GTK_WIDGET(pb));

    gtk_widget_show(GTK_WIDGET(img));
    gtk_widget_show(GTK_WIDGET(pb));
    gtk_widget_show(GTK_WIDGET(box));

    new_data=false;
    done=false;
}

void SplashWindow::SetProgress(int percent, char *text) {
    //while (new_data) {
        //Sleep(10);
    //}
    semp(sem_lock);
    data=text;
    this->percent=percent;
    new_data=true;
    semv(sem_lock);
}

bool SplashWindow::my_idle() {
    semp(sem_lock);
    if (new_data) {
        AnsiString S="Loading ";
        S+=AnsiString((long)percent);
        S+="%";
        gtk_window_set_title(handle, S.c_str());
        gtk_progress_bar_set_text(pb, data.c_str());
        gtk_progress_bar_set_fraction(pb,(float)percent/100);
        new_data=false;
        if (percent>=100)
            done=true;
    }/* else*/
    if (done) {
        done=false;
        gtk_dialog_response (GTK_DIALOG(handle), GTK_RESPONSE_OK);
        semv(sem_lock);
        return false;
    }
    semv(sem_lock);
    return true;
}

void SplashWindow::show() {
    gtk_widget_show(GTK_WIDGET(handle));
}

void SplashWindow::run() {
    gtk_dialog_run(GTK_DIALOG(handle));
}

void SplashWindow::hide() {
    gtk_dialog_response (GTK_DIALOG(handle), GTK_RESPONSE_OK);
    gtk_widget_hide(GTK_WIDGET(handle));
}

void SplashWindow::destroy() {
    gtk_widget_hide(GTK_WIDGET(handle));
    gtk_widget_destroy(GTK_WIDGET(handle));
}

void SplashWindow::done_wnd(bool done) {
    semp(sem_lock);
    gtk_dialog_response (GTK_DIALOG(handle), GTK_RESPONSE_OK);
    //gtk_widget_hide(GTK_WIDGET(handle));
    this->done=done;
    semv(sem_lock);
}

SplashWindow::~SplashWindow() {
}
