#include <zip.h>
#include <string.h>
#include <dirent.h>

#ifndef _WIN32
	#include <sys/types.h>
	#include <sys/wait.h>
	#include <sys/stat.h>
	#include <fcntl.h>
	#include <unistd.h>
#endif

#define MAX_FILE_SIZE		8192*1024*2

void DoDirectory(char *filename) {
	char DIR_BUFFER[8192];
	DIR_BUFFER[0]=0;
	int len=strlen(filename);
	
	int dir_index=0;
	for (int i=0;i<len;i++) {
		char c=filename[i];
		if ((c=='/') || (c=='\\')) {
			if (DIR_BUFFER[0]) {
#ifdef _WIN32
				mkdir(DIR_BUFFER);
#else
				mkdir(DIR_BUFFER, 0777L);
#endif
				//DIR_BUFFER[0]=0;
				//dir_index=0;
			}
		}
		DIR_BUFFER[dir_index++]=c;
		DIR_BUFFER[dir_index]=0;
	}
}


int UnZip(char *filename) {
	int err_no=0;
	zip *z=zip_open(filename, ZIP_CHECKCONS, &err_no);
	if (z) {
		int num_files=zip_get_num_files(z);
		char *buffer=new char[MAX_FILE_SIZE];

		for (int i=0;i<num_files;i++) {
			char *name=(char *)zip_get_name(z, i, 0);
			if (name) {
				DoDirectory(name);

				zip_file *zf=zip_fopen_index(z, i, 0);
				if (zf) {
					int size=zip_fread(zf, buffer, MAX_FILE_SIZE);
					if (size>=0) {
						FILE *f=fopen(name, "wb");
						if (f) {
							fwrite((void *)buffer, 1, size, f);
							fclose(f);
						}
					}
					zip_fclose(zf);
				}
			}
		}
		delete[] buffer;
		zip_close(z);
	}
	return err_no;
}
